#*************************************************************
# Progamm:			korrelations_koeffizient
# Sinn des Programms: 		Korrelationskoeffizient
# Sinn der Einheit  :		Berechnen der Korrelationskoeffizienten 
#				aus 2 Zufallsreihen und 2 Sinusfunktionen	
# Name dieser Datei:		rechner.py
# Versionsnummer:		1
# Wird aufgerufen von:		korrelations_koeffizient.py
# Ruft auf:			-
# Nummer im Programmpaket:	4
# von:				5			
# Autor: 			Armin Ulrich
# Erster Lauf: 			15.09.2018
# Letzte Änderung: 		30.03.2020
#*************************************************************
import random
import math
class Rechner:

 

  def zufallszahlen(self,m):
    print("Zufallszahlen")
    
    self.zufall_1=list(range(m))
    self.zufall_2=list(range(m))
   # print(self.zufall_1)
   # print(self.zufall_2)
    random.seed()
    for i in range(0,m):
      a = random.random()
      self.zufall_1[i]=a
    for i in range(0,m):
      b = random.random()
      #print(i)
      self.zufall_2[i]=b  

    # print(self.zufall_1)
    # print(self.zufall_2)
    self.zufall_k_k=self.korrelationskoeffizient(m,self.zufall_1,self.zufall_2)
    print("korrel_zufall:",self.zufall_k_k)
  
  def klimareihen(self,m,y_1,y_2):
    print("Klimareihen")
    
    self.klima_k_k=self.korrelationskoeffizient(m,y_1,y_2)
    print("Korrelations_Koeffizient Klima:",self.klima_k_k)



  def korrelationskoeffizient(self,m,x,y):
    print("Korrelationskoeffizient")
    
#*************************************************************
# Berechnung der Mittelwerte fuer beide Reihen: x, y
#*************************************************************

    x_quer=self.mittelwert(m,x)
    y_quer=self.mittelwert(m,y)
#*************************************************************
# Berechnung der Zwischenwerte zählersumme, nennersumme_x,
# nennersumme_y nach vorheriger Initialisierung: 
# zählersumme=nennersumme_x=nennersumme_y=0.0 vor der 
# Zählschleife
#*************************************************************

    zählersumme=0.0
    
    for i in range(0,m):
      zählersumme=zählersumme+(x[i]-x_quer)*(y[i]-y_quer)  
  
    nennersumme_x=0.0
    for i in range(0,m):
      nennersumme_x=nennersumme_x+(x[i]-x_quer)**2


    nennersumme_y=0.0
    for i in range(0,m): 
      nennersumme_y=nennersumme_y+(y[i]-y_quer)**2
    kk=zählersumme/math.sqrt(nennersumme_x*nennersumme_y)
    return kk
 
  def mittelwert(self,m,z):
    print("Mittelwert")
    z_quer=0.0

    for i in range(0,m):
      z_quer=z_quer+z[i]
    z_quer=z_quer/float(m) 
    print("Mittelwert=",z_quer)
    return z_quer
    

    


